package com.dsic.gj_erp.controller.jcsj;


import com.dsic.gj_erp.annotation.AuthFunction;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.jcsj.DmBzzz;
import com.dsic.gj_erp.service.jcsj.DmBzzzService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;
import java.util.stream.Collectors;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author xn
 * @since 2024-05-30
 */
@RestController
@RequestMapping("/dmBzzz")
public class DmBzzzController {

    @Autowired
    DmBzzzService service;

    @PostMapping(value = "/getList")
    public ResultBean getList(@RequestBody DmBzzz t){
        List<DmBzzz> list=service.list();
        return new ResultBean(list);
    }
    @AuthFunction()
    @PostMapping(value = "/save")
    public ResultBean save(@RequestBody DmBzzz team){
        service.save(team);
        return new ResultBean();
    }

    @AuthFunction()
    @PostMapping(value = "/update")
    public ResultBean update(@RequestBody DmBzzz team){
        service.updateById(team);
        return new ResultBean();
    }

    @AuthFunction()
    @PostMapping(value = "/del")
    public ResultBean del(@RequestBody List<DmBzzz> list){
        List<String> idList=list.stream().map(DmBzzz::getId).collect(Collectors.toList());
        service.removeByIds(idList);
        return new ResultBean();
    }
}

