package com.dsic.gj_erp.listeners;

import com.alibaba.excel.context.AnalysisContext;
import com.alibaba.excel.event.AnalysisEventListener;
import com.dsic.gj_erp.bean.jhgk.excel.JhxfExcel;
import com.dsic.gj_erp.util.ObjConvertUtils;
import org.apache.commons.lang3.StringUtils;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * Excel通用监听器
 */
public class ExcelJhxfListener extends AnalysisEventListener<JhxfExcel> {

    private static final int BATCH_COUNT = 5;

    List<JhxfExcel> objectList = new ArrayList<>();
    List<Object> headList = new ArrayList<>();
    private String sheetName;

    List<JhxfExcel> datas = new ArrayList<JhxfExcel>();

    private String dcch;
    private String dcpl;

    @Override
    public void invoke(JhxfExcel excelDemo, AnalysisContext analysisContext) {
    	//每解析一行数据，就会调用该方法一次
        //正常在这里调用数据处理得办法

        //一条数据添加到暂时存储的存储结构中


        if(StringUtils.isBlank(excelDemo.getDcCh())){
            excelDemo.setDcCh(dcch);
        }else{
            dcch=excelDemo.getDcCh();
        }
        if(StringUtils.isBlank(excelDemo.getDcPl())){
            excelDemo.setDcPl(dcpl);
        }else{
            dcpl=excelDemo.getDcPl();
        }
            boolean a=false;
        //  9个数量都为空  不导入
//        if(StringUtils.isBlank(excelDemo.getBs1()) &&
//            StringUtils.isBlank(excelDemo.getYklm())&&
//            StringUtils.isBlank(excelDemo.getYksk())&&
//            StringUtils.isBlank(excelDemo.getEklmbs())&&
//            StringUtils.isBlank(excelDemo.getEksk())&&
//            StringUtils.isBlank(excelDemo.getSksk())&&
//            StringUtils.isBlank(excelDemo.getSkpt())&&
//            StringUtils.isBlank(excelDemo.getFbbs())&&
//            StringUtils.isBlank(excelDemo.getSkbs())
//        ){
//            a=true;
//        }


//        boolean b = ObjConvertUtils.checkObjAllFieldsIsNull(excelDemo);
//        if(!b && !a){
//            datas.add(excelDemo);
//        }
        datas.add(excelDemo);




        // 达到BATCH_COUNT了，需要去存储一次数据库，防止数据几万条数据在内存，容易OOM
        if (datas.size() >= BATCH_COUNT) {
            saveData();
            // 存储完成清理 list
            datas.clear();
        }
    }




    @Override
    public void doAfterAllAnalysed(AnalysisContext context) {
        //获取sheetName
        saveData();
        sheetName = context.readSheetHolder().getSheetName();
//        LOGGER.info("所有数据解析完成！");
    }

    //获取表头
    @Override
    public void invokeHeadMap(Map<Integer, String> headMap, AnalysisContext context) {
        //把表头数据加入到存储结构中
        headList.add(headMap);
    }

    /**
     * 入库
     */
    private void saveData() {
        //添加到返回的存储结构中，也可直接存储到数据库
        objectList.addAll(datas);
    }

    public List<JhxfExcel> getDatas() {
        return datas;
    }

    public void setDatas(List<JhxfExcel> datas) {
        this.datas = datas;
    }

    public List<JhxfExcel> getObjectList() {
        return objectList;
    }

    public void setObjectList(List<JhxfExcel> objectList) {
        this.objectList = objectList;
    }

    public String getSheetName() {
        return sheetName;
    }

    public void setSheetName(String sheetName) {
        this.sheetName = sheetName;
    }

    public List<Object> getHeadList() {
        return headList;
    }

    public void setHeadList(List<Object> headList) {
        this.headList = headList;
    }

    public String getDcch() {
        return dcch;
    }

    public void setDcch(String dcch) {
        this.dcch = dcch;
    }

    public String getDcpl() {
        return dcpl;
    }

    public void setDcpl(String dcpl) {
        this.dcpl = dcpl;
    }
}
